# KERNEL-specific commands (EliteKernel version)
# default CPU settings
echo "smartassV2"   > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
echo "122880"   > /sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq
echo "1228800"   > /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq

# tweak smartass1 (not present in this kernel)
#echo 100000   > /sys/devices/system/cpu/cpu0/cpufreq/smartass/down_rate_us
#echo 94   > /sys/devices/system/cpu/cpu0/cpufreq/smartass/max_cpu_load
#echo 45   > /sys/devices/system/cpu/cpu0/cpufreq/smartass/min_cpu_load
#echo 768000   > /sys/devices/system/cpu/cpu0/cpufreq/smartass/up_min_freq
#echo 368640   > /sys/devices/system/cpu/cpu0/cpufreq/smartass/sleep_max_freq
#echo 768000   > /sys/devices/system/cpu/cpu0/cpufreq/smartass/max_ramp_down

# tweak smartass2 (included in kernel)
#echo 768000   > /sys/devices/system/cpu/cpufreq/smartass/awake_ideal_freq
#echo 100000   > /sys/devices/system/cpu/cpufreq/smartass/down_rate_us
#echo 94   > /sys/devices/system/cpu/cpufreq/smartass/max_cpu_load
#echo 66   > /sys/devices/system/cpu/cpufreq/smartass/min_cpu_load
#echo 256000   > /sys/devices/system/cpu/cpufreq/smartass/ramp_down_step
#echo 256000   > /sys/devices/system/cpu/cpufreq/smartass/ramp_up_step
#echo 245000   > /sys/devices/system/cpu/cpufreq/smartass/sleep_ideal_freq
#echo 768000   > /sys/devices/system/cpu/cpufreq/smartass/sleep_wakeup_freq
#echo 50000   > /sys/devices/system/cpu/cpufreq/smartass/up_rate_us

# Tweak VM (some included in kernel)
sysctl -w vm.min_free_kbytes=5242
sysctl -w vm.vfs_cache_pressure=30
sysctl -w vm.swappiness=40
sysctl -w vm.page-cluster=0
sysctl -w vm.dirty_expire_centisecs=2400
sysctl -w vm.dirty_writeback_centisecs=600
sysctl -w vm.dirty_ratio=20
sysctl -w vm.dirty_background_ratio=30
sysctl -w vm.oom_kill_allocating_task=0
sysctl -w vm.panic_on_oom=0
sysctl -w vm.overcommit_memory=0
sysctl -w vm.overcommit_ratio=20
sysctl -w kernel.panic_on_oops=1
sysctl -w kernel.panic=10


# tweak internal memory manager
echo "0,1,2,5,7,15" > /sys/module/lowmemorykiller/parameters/adj
echo "1536,3072,6144,11264,16384,20480" > /sys/module/lowmemorykiller/parameters/minfree

# this line locks minfree until reboot! (hack for AOKP bug)
chmod 0444 /sys/module/lowmemorykiller/parameters/minfree
chmod 0444 /sys/module/lowmemorykiller/parameters/adj

#echo "1536,2048,4096,8192,10240,12288" > /sys/module/lowmemorykiller/parameters/minfile

# select default schedulers (included in kernel)
#echo "sio" > /sys/block/mmcblk0/queue/scheduler;
#echo "sio" > /sys/block/mmcblk1/queue/scheduler;
sync


##### THIS SHOULD BE IN ROM INIT!!
# attempt to mount SD card before GUI to prevent LP FC's
mount -w -t vfat -o async,nosuid,noatime,nodiratime,nodev,noexec,relatime,nobh /dev/block/vold/179:65 /mnt/sdcard
sync
mount -w -t vfat -o async,remount,nosuid,noatime,nodiratime,nodev,noexec,relatime,nobh /dev/block/vold/179:65 /mnt/sdcard
sync

# enable asynchronous writes for data and cache
mount -o async,remount,noatime,nodiratime,delalloc,noauto_da_alloc,barrier=0,nobh /cache /cache
mount -o async,remount,noatime,nodiratime,delalloc,noauto_da_alloc,barrier=0,nobh /data /data
mount -o async,remount,noatime,nodiratime,delalloc,noauto_da_alloc,barrier=0,nobh /sd-ext /sd-ext
mount -o async,remount,noatime,nodiratime,delalloc,noauto_da_alloc,barrier=0,nobh /devlog /devlog

# SD card read buffer
echo "2048" > /sys/devices/virtual/bdi/179:0/read_ahead_kb;

# sd-ext read buffer
echo "2048" > /sys/block/mmcblk1/bdi/read_ahead_kb;
echo "2048" > /sys/block/mmcblk1/queue/read_ahead_kb;

# internal storage read buffer
echo "2048" > /sys/block/mmcblk0/bdi/read_ahead_kb;
echo "2048" > /sys/block/mmcblk0/queue/read_ahead_kb;
